ArgumentException ArgumentException ArgumentException ArgumentException Class

정의

메서드에 제공된 인수 중 하나가 유효하지 않을 때 throw되는 예외입니다.The exception that is thrown when one of the arguments provided to a method is not valid.

public ref class ArgumentException : SystemException
[System.Runtime.InteropServices.ComVisible(true)]
[System.Serializable]
public class ArgumentException : SystemException
type ArgumentException = class
    inherit SystemException
    interface ISerializable
Public Class ArgumentException
Inherits SystemException
상속
파생
특성
구현

예제

다음 예제에는 throw 및 catch 하는 방법을 보여 줍니다.는 ArgumentException합니다.The following example demonstrates how to throw and catch an ArgumentException. 사용 된 ArgumentException.GetType() 합니다. 이름을 는 예외 개체를 사용 하 여도의 이름을 표시 하는 속성을 Message 예외 메시지의 텍스트를 표시 하는 속성입니다.It uses the ArgumentException.GetType().Name property to display the name of the exception object, and also uses the Message property to display the text of the exception message.

using namespace System;

static int DivideByTwo(int num) 
{
    // If num is an odd number, throw an ArgumentException.
    if ((num & 1) == 1)
        throw gcnew ArgumentException(String::Format("{0} is not an even number", num), 
                                      "num");

    // num is even, return half of its value.
    return num / 2;
}

void main() 
{
    // Define some integers for a division operation.
    array<int>^ values = { 10, 7 };
    for each (int value in values) {
        try {
           Console::WriteLine("{0} divided by 2 is {1}", value, DivideByTwo(value));
        }
        catch (ArgumentException^ e) {
           Console::WriteLine("{0}: {1}", e->GetType()->Name, e->Message);
        }
        Console::WriteLine();
    }
}
// This example displays the following output:
//     10 divided by 2 is 5
//     
//     ArgumentException: 7 is not an even number
//     Parameter name: num
using System;

public class Example 
{
    static void Main() 
    {
        // Define some integers for a division operation.
        int[] values = { 10, 7 };
        foreach (var value in values) {
            try {
               Console.WriteLine("{0} divided by 2 is {1}", value, DivideByTwo(value));
            }
            catch (ArgumentException e) {
               Console.WriteLine("{0}: {1}", e.GetType().Name, e.Message);
            }
            Console.WriteLine();
        }
    }

    static int DivideByTwo(int num) 
    {
        // If num is an odd number, throw an ArgumentException.
        if ((num & 1) == 1)
            throw new ArgumentException(String.Format("{0} is not an even number", num), 
                                      "num");

        // num is even, return half of its value.
        return num / 2;
    }
}
// This example displays the following output:
//     10 divided by 2 is 5
//     
//     ArgumentException: 7 is not an even number
//     Parameter name: num
Public Class Example
    Public Shared Sub Main()
        ' Define some integers for a division operation.
        Dim values() As Integer = { 10, 7 }

        For Each value In values
            Try 
               Console.WriteLine("{0} divided by 2 is {1}", value, DivideByTwo(value))
            Catch e As ArgumentException
               Console.WriteLine("{0}: {1}", e.GetType().Name, e.Message)
            End Try
            Console.WriteLine()
        Next
    End Sub
    
    Private Shared Function DivideByTwo(ByVal num As Integer) As Integer
        ' If num is an odd number, throw an ArgumentException.
        If (num And 1) = 1 Then
            Throw New ArgumentException(String.Format("{0} is not an even number", num), 
                                      "num")
        End If
        Return num \ 2
    End Function
End Class
' The example displays the following output:
'     10 divided by 2 is 5
'     
'     ArgumentException: 7 is not an even number
'     Parameter name: num

설명

ArgumentException 메서드를 호출 하 고 전달된 된 인수 중 하나 이상 호출 된 메서드의 매개 변수 사양에 맞지 않습니다 때 throw 됩니다.ArgumentException is thrown when a method is invoked and at least one of the passed arguments does not meet the parameter specification of the called method. ParamName 속성은 잘못 된 인수를 식별 합니다.The ParamName property identifies the invalid argument.

가장 일반적으로 ArgumentException 공용 언어 런타임 또는 다른 클래스 라이브러리에서 throw 되 고 개발자 오류를 나타냅니다.Most commonly, an ArgumentException is thrown by the common language runtime or another class library and indicates developer error. Throw 되는 경우는 ArgumentException 코드에서 확인 해야 하는 예외의 Message 속성에 잘못 된 인수 및 인수에 대 한 값의 예상된 범위를 설명 하는 의미 있는 오류 메시지가 포함 됩니다.If you throw an ArgumentException from your code, you should ensure that the exception's Message property includes a meaningful error message that describes the invalid argument and the expected range of values for the argument.

기본 클래스를 파생 ArgumentException 됩니다 ArgumentNullExceptionArgumentOutOfRangeException합니다.The primary derived classes of ArgumentException are ArgumentNullException and ArgumentOutOfRangeException. 이러한 파생된 클래스를 대신 사용할지 ArgumentException, 모두 파생된 클래스는 허용 되는 경우에서를 제외 하 고 있습니다.These derived classes should be used instead of ArgumentException, except in situations where neither of the derived classes is acceptable. 예를 들어, 예외에서 throw 되어야 합니다.For example, exceptions should be thrown by:

  • ArgumentNullException 때마다 null 를 올바른 인수로 받아들이지 않는 메서드에 전달 됩니다.ArgumentNullException whenever null is passed to a method that does not accept it as a valid argument.

  • ArgumentOutOfRangeException 인수 값이 허용 가능한 값의 범위를 벗어납니다 예를 들어, "46" 값은 전달 되 면 월 인수로 만드는 동안는 DateTime합니다.ArgumentOutOfRangeException when the value of an argument is outside the range of acceptable values; for example, when the value "46" is passed as the month argument during the creation of a DateTime.

오류 자체가 인수 후 관련이 없는 경우 또는 메서드 호출에 인수가 없는 경우 InvalidOperationException 사용 해야 합니다.If the method call does not have any argument or if the failure does not involve the arguments themselves, then InvalidOperationException should be used.

ArgumentException 0x80070057 값을 HRESULT COR_E_ARGUMENT를 사용 합니다.ArgumentException uses the HRESULT COR_E_ARGUMENT, which has the value 0x80070057.

인스턴스의 초기 속성 값의 목록을 ArgumentException, 참조는 ArgumentException 생성자입니다.For a list of initial property values for an instance of ArgumentException, see the ArgumentException constructors.

생성자

ArgumentException() ArgumentException() ArgumentException() ArgumentException()

ArgumentException 클래스의 새 인스턴스를 초기화합니다.Initializes a new instance of the ArgumentException class.

ArgumentException(SerializationInfo, StreamingContext) ArgumentException(SerializationInfo, StreamingContext) ArgumentException(SerializationInfo, StreamingContext) ArgumentException(SerializationInfo, StreamingContext)

serialize된 데이터를 사용하여 ArgumentException 클래스의 새 인스턴스를 초기화합니다.Initializes a new instance of the ArgumentException class with serialized data.

ArgumentException(String) ArgumentException(String) ArgumentException(String) ArgumentException(String)

지정된 오류 메시지를 사용하여 ArgumentException 클래스의 새 인스턴스를 초기화합니다.Initializes a new instance of the ArgumentException class with a specified error message.

ArgumentException(String, Exception) ArgumentException(String, Exception) ArgumentException(String, Exception) ArgumentException(String, Exception)

지정된 오류 메시지와 해당 예외의 원인인 내부 예외에 대한 참조를 사용하여 ArgumentException 클래스의 새 인스턴스를 초기화합니다.Initializes a new instance of the ArgumentException class with a specified error message and a reference to the inner exception that is the cause of this exception.

ArgumentException(String, String) ArgumentException(String, String) ArgumentException(String, String) ArgumentException(String, String)

지정된 오류 메시지와 이 예외를 발생한 매개 변수의 이름을 사용하여 ArgumentException 클래스의 새 인스턴스를 초기화합니다.Initializes a new instance of the ArgumentException class with a specified error message and the name of the parameter that causes this exception.

ArgumentException(String, String, Exception) ArgumentException(String, String, Exception) ArgumentException(String, String, Exception) ArgumentException(String, String, Exception)

지정된 오류 메시지, 매개 변수 이름 및 이 예외의 원인인 내부 예외에 대한 참조를 사용하여 ArgumentException 클래스의 새 인스턴스를 초기화합니다.Initializes a new instance of the ArgumentException class with a specified error message, the parameter name, and a reference to the inner exception that is the cause of this exception.

속성

Data Data Data Data

예외에 대한 사용자 정의 추가 정보를 제공하는 키/값 쌍의 컬렉션을 가져옵니다.Gets a collection of key/value pairs that provide additional user-defined information about the exception.

(Inherited from Exception)
HelpLink HelpLink HelpLink HelpLink

이 예외와 연결된 도움말 파일에 대한 링크를 가져오거나 설정합니다.Gets or sets a link to the help file associated with this exception.

(Inherited from Exception)
HResult HResult HResult HResult

특정 예외에 할당된 코드화된 숫자 값인 HRESULT를 가져오거나 설정합니다.Gets or sets HRESULT, a coded numerical value that is assigned to a specific exception.

(Inherited from Exception)
InnerException InnerException InnerException InnerException

현재 예외를 발생시킨 Exception 인스턴스를 가져옵니다.Gets the Exception instance that caused the current exception.

(Inherited from Exception)
Message Message Message Message

오류 메시지 및 매개 변수 이름을 가져오거나, 매개 변수 이름이 설정되지 않은 경우에는 오류 메시지만 가져옵니다.Gets the error message and the parameter name, or only the error message if no parameter name is set.

ParamName ParamName ParamName ParamName

이 예외를 발생시킨 매개 변수의 이름을 가져옵니다.Gets the name of the parameter that causes this exception.

Source Source Source Source

오류를 발생시키는 애플리케이션 또는 개체의 이름을 가져오거나 설정합니다.Gets or sets the name of the application or the object that causes the error.

(Inherited from Exception)
StackTrace StackTrace StackTrace StackTrace

호출 스택의 직접 실행 프레임에 대한 문자열 표현을 가져옵니다.Gets a string representation of the immediate frames on the call stack.

(Inherited from Exception)
TargetSite TargetSite TargetSite TargetSite

현재 예외를 throw하는 메서드를 가져옵니다.Gets the method that throws the current exception.

(Inherited from Exception)

메서드

Equals(Object) Equals(Object) Equals(Object) Equals(Object)

지정한 개체와 현재 개체가 같은지 여부를 확인합니다.Determines whether the specified object is equal to the current object.

(Inherited from Object)
GetBaseException() GetBaseException() GetBaseException() GetBaseException()

파생 클래스에서 재정의되었을 때, 하나 이상의 후속 예외의 근본 원인이 되는 Exception을 반환합니다.When overridden in a derived class, returns the Exception that is the root cause of one or more subsequent exceptions.

(Inherited from Exception)
GetHashCode() GetHashCode() GetHashCode() GetHashCode()

기본 해시 함수로 작동합니다.Serves as the default hash function.

(Inherited from Object)
GetObjectData(SerializationInfo, StreamingContext) GetObjectData(SerializationInfo, StreamingContext) GetObjectData(SerializationInfo, StreamingContext) GetObjectData(SerializationInfo, StreamingContext)

매개 변수 이름 및 추가 예외 정보를 사용하여 SerializationInfo 개체를 설정합니다.Sets the SerializationInfo object with the parameter name and additional exception information.

GetType() GetType() GetType() GetType()

현재 인스턴스의 런타임 형식을 가져옵니다.Gets the runtime type of the current instance.

(Inherited from Exception)
MemberwiseClone() MemberwiseClone() MemberwiseClone() MemberwiseClone()

현재 Object의 단순 복사본을 만듭니다.Creates a shallow copy of the current Object.

(Inherited from Object)
ToString() ToString() ToString() ToString()

현재 예외에 대한 문자열 표현을 만들고 반환합니다.Creates and returns a string representation of the current exception.

(Inherited from Exception)

이벤트

SerializeObjectState SerializeObjectState SerializeObjectState SerializeObjectState

예외에 대한 serialize된 데이터가 들어 있는 예외 상태 개체가 만들어지도록 예외가 serialize될 때 발생합니다.Occurs when an exception is serialized to create an exception state object that contains serialized data about the exception.

(Inherited from Exception)

적용 대상

추가 정보